# Copyright 2017 Google Inc.
#
# Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.


# NOTE: This class is auto generated by the swagger code generator program.
# https://github.com/swagger-api/swagger-codegen.git
# Do not edit the class manually.

defmodule GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings do
  @moduledoc """
  Settings specific to content ads (AFC) and highend mobile content ads (AFMC - deprecated).

  ## Attributes

  - backupOption (AdUnitContentAdsSettingsBackupOption):  Defaults to: `null`.
  - size (String): Size of this ad unit. Size values are in the form SIZE_{width}_{height}. Defaults to: `null`.
  - type (String): Type of this ad unit. Possible values are TEXT, TEXT_IMAGE, IMAGE and LINK. Defaults to: `null`.
  """

  defstruct [
    :"backupOption",
    :"size",
    :"type"
  ]
end

defimpl Poison.Decoder, for: GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings do
  import GoogleApi.AdSenseHost.V41.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:"backupOption", :struct, GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettingsBackupOption, options)
  end
end

defimpl Poison.Encoder, for: GoogleApi.AdSenseHost.V41.Model.AdUnitContentAdsSettings do
  def encode(value, options) do
    GoogleApi.AdSenseHost.V41.Deserializer.serialize_non_nil(value, options)
  end
end

